


/********************************************************************************/
/*																				*/
/********************************************************************************/
#define	uchar	unsigned char
#define	byte	unsigned char
#define	uint	unsigned int
#define	word	unsigned int
#define	ulong	unsigned long
#define	dword	unsigned long
#define	FALSE	0
#define	TRUE	1
#define	false	FALSE
#define	true	TRUE
#define	False	FALSE
#define	True	TRUE


#define	NONE		-1
#define	PARITYERR	-2
#define	FRAMEERR	-3
#define	OVERRUNERR	-4

#define	CRLF	"\r\n"
#define	CR		'\r'
#define	LF		'\n'
#define	ESC		0x2B
#define	EXIT	ESC


#define	CNT0_PRESCALER_0		0
#define	CNT0_PRESCALER_1		1
#define	CNT0_PRESCALER_8		2
#define	CNT0_PRESCALER_64		3
#define	CNT0_PRESCALER_256		4
#define	CNT0_PRESCALER_1024		5
#define	CNT0_PRESCALER_T0faling	6
#define	CNT0_PRESCALER_T0rising	7

#define	CNT1_PRESCALER_0		0
#define	CNT1_PRESCALER_1		1
#define	CNT1_PRESCALER_8		2
#define	CNT1_PRESCALER_64		3
#define	CNT1_PRESCALER_256		4
#define	CNT1_PRESCALER_1024		5
#define	CNT1_PRESCALER_T1faling	6
#define	CNT1_PRESCALER_T1rising	7

#define	CNT2_PRESCALER_0		0
#define	CNT2_PRESCALER_1		1
#define	CNT2_PRESCALER_8		2
#define	CNT2_PRESCALER_32		3
#define	CNT2_PRESCALER_64		4
#define	CNT2_PRESCALER_128		5
#define	CNT2_PRESCALER_256		6
#define	CNT2_PRESCALER_1024		7



#include <avr/io.h>									// IO
#include <stdio.h>									//
#include <stdlib.h>									//
#include <avr/sfr_defs.h>							// SFR, _BV(bit)
#include <avr/pgmspace.h>							// Flash
#define  CODE PROGMEM
#include <avr/interrupt.h>							// wektory IRQ
#include <avr/wdt.h> 								// WDG
#include <avr/eeprom.h>								// Eeprom
#include <string.h>									// Stringi
#include <compat/deprecated.h>						// sbi, cbi, inb, outb, outp
#define  ebi(port,bit) ( port ^= (1 << (bit)))		// Negowanie bitu na porcie
#define	BAUD	250000
#include <util/setbaud.h>							// Uart 0
//#define	BAUD1	9600
//#include "include/setbaud1.h"						// Uart 1
#include <util/delay.h>
#include <util/crc16.h>								// Crc16, Xmodem, Dallas
#include <avr/fuse.h>
#define NOINIT __attribute__ ((section(".noinit")))
#define nop()	__asm__ __volatile__( "nop" )		// Wstawia rozkaz NOP do kodu
#include <avr/sleep.h>								// Tryby upienia
#include <avr/power.h>								// Wyaczanie peryferii



//---------------------------------------------------------------------------------------
/*
// Interrupt Vectors
// Interrupt Vector 0 is the reset vector.
#define INT0_vect         _VECTOR(1)   // External Interrupt Request 0
#define INT1_vect         _VECTOR(2)   // External Interrupt Request 1
#define PCINT0_vect       _VECTOR(3)   // Pin Change Interrupt Request 0
#define PCINT1_vect       _VECTOR(4)   // Pin Change Interrupt Request 0
#define PCINT2_vect       _VECTOR(5)   // Pin Change Interrupt Request 1
#define WDT_vect          _VECTOR(6)   // Watchdog Time-out Interrupt
#define TIMER2_COMPA_vect _VECTOR(7)   // Timer/Counter2 Compare Match A
#define TIMER2_COMPB_vect _VECTOR(8)   // Timer/Counter2 Compare Match A
#define TIMER2_OVF_vect   _VECTOR(9)   // Timer/Counter2 Overflow
#define TIMER1_CAPT_vect  _VECTOR(10)  // Timer/Counter1 Capture Event
#define TIMER1_COMPA_vect _VECTOR(11)  // Timer/Counter1 Compare Match A
#define TIMER1_COMPB_vect _VECTOR(12)  // Timer/Counter1 Compare Match B 
#define TIMER1_OVF_vect   _VECTOR(13)  // Timer/Counter1 Overflow
#define TIMER0_COMPA_vect _VECTOR(14)  // TimerCounter0 Compare Match A
#define TIMER0_COMPB_vect _VECTOR(15)  // TimerCounter0 Compare Match B
#define TIMER0_OVF_vect   _VECTOR(16)  // Timer/Couner0 Overflow
#define SPI_STC_vect      _VECTOR(17)  // SPI Serial Transfer Complete
#define USART_RX_vect     _VECTOR(18)  // USART Rx Complete
#define USART_UDRE_vect   _VECTOR(19)  // USART, Data Register Empty
#define USART_TX_vect     _VECTOR(20)  // USART Tx Complete
#define ADC_vect          _VECTOR(21)  // ADC Conversion Complete
#define EE_READY_vect     _VECTOR(22)  // EEPROM Ready
#define ANALOG_COMP_vect  _VECTOR(23)  // Analog Comparator
#define TWI_vect          _VECTOR(24)  // Two-wire Serial Interface
#define SPM_READY_vect    _VECTOR(25)  // Store Program Memory Read

void* tim_handler;
ISR(TIMER2_COMP_vect,ISR_NAKED)
{
asm("ijmp"::"z"(tim_handler));
}

Skoro "program gwny" nic nie robi to przerwanie nigdy nie moe zepsu jego stanu, a wic nie ma powodu eby obsuga przerwan zapisywaa rejestry czy cokolwiek - dlatego ISR_NAKED.


*/



//---------------------------------------------------------------------------------------
#define	OVERTIME_DMX	1 * 100		// Liczba sekund do trybu ofline w 10ms
word volatile TimerDmx0, TimerDmx1, TimerLcd;
void InitTimer0();
void InitTimer2();
void InitTimer1();

#define	IMPdataMASK		0x1F
byte volatile IMPdata	= 256/16;
byte eeIMPdata EEMEM	= 256/16;

#define	RdImpSw		(PINB & (1<<PINB7) )
#define	ddrImpSw()	PORTB |=(1<<PINB7) 
#define	RdImpA		(PIND & (1<<PIND0) )
#define	RdImpB		(PIND & (1<<PIND1) )
void InitInt0();
void InitInt1();


#define	ddrLedRun()	DDRB  |=  (1<<PB5) 
#define	SetLedRun()	PORTB &= ~(1<<PB5)
#define	ClrLedRun()	PORTB |=  (1<<PB5)
#define	EorLedRun()	PORTB ^=  (1<<PB5)


#define	MIN_DMX_OFLINE	1			// Czas braku transmisji w sekundach, uznany jako brak sygnalu DMX
enum{DMX_OFFLINE, DMX_BREAK};


#define	LENBUFDMX	513
void InitUart0();
byte RxBuf0[ LENBUFDMX ];
byte TxBuf0[ LENBUFDMX ];
byte DmxStatus0 = DMX_OFFLINE;
word volatile LenDmx0, PtrTxRs;
byte volatile TxEmpty = TRUE;

#define	DdrTx()			DDRE  |=  (1<<PE1);			// Port wyjsciem
#define	ClrTx()			PORTE &= ~(1<<PE1);			// wygeneruj BREAK
#define	SetTx()			PORTE |=  (1<<PE1);			// wygeneruj MAB
void SendDmx( word len );
word LenTxRs;

void InitUart1();
byte RxBuf1[ LENBUFDMX ];
byte DmxStatus1 = DMX_OFFLINE;
word volatile LenDmx1;



//#define	LCD8BIT				// Uycie definicji wcza tryb 8-bit
//-------------------------- LCD ----------------------------------//
#define	LcdRSddr	DDRE  |=  (1<<PE7)
#define	LcdRSset	PORTE |=  (1<<PE7)
#define	LcdRSclr	PORTE &= ~(1<<PE7)

#define	LcdEddr		DDRE  |=  (1<<PE6)
#define	LcdEset		PORTE |=  (1<<PE6)
#define	LcdEclr		PORTE &= ~(1<<PE6)

#define	LcdD4ddr	DDRE  |=  (1<<PE5)
#define	LcdD4set	PORTE |=  (1<<PE5)
#define	LcdD4clr	PORTE &= ~(1<<PE5)

#define	LcdD5ddr	DDRE  |=  (1<<PE4)
#define	LcdD5set	PORTE |=  (1<<PE4)
#define	LcdD5clr	PORTE &= ~(1<<PE4)

#define	LcdD6ddr	DDRE  |=  (1<<PE3)
#define	LcdD6set	PORTE |=  (1<<PE3)
#define	LcdD6clr	PORTE &= ~(1<<PE3)

#define	LcdD7ddr	DDRE  |=  (1<<PE2)
#define	LcdD7set	PORTE |=  (1<<PE2)
#define	LcdD7clr	PORTE &= ~(1<<PE2)

//-------------------------- LCD ----------------------------------//
void LcdInit();
void LcdDataOut();
void LcdPutCGRAM(byte NrZnaku);
void LcdSendCommand(unsigned char command);
void LcdSendNible(unsigned char command);
void LcdSendByte(unsigned char command);
void LcdSendData(unsigned char data);
void LcdSetCursorPosition(unsigned char row,unsigned char line);
void LcdPrint(char *text);
void LcdPrint_P(char *text);
void LcdPrintChar(char character);
char LcdWin2Lcd(char znak);
void LcdNextLine();
void LcdClr();
#define	LcdCls	LcdClr
#define	LCDLINE	2			// Liczba wierszy
#define	LCDROW	16			// Liczba kolumn
#define	LcdDispayOn()	LcdSendCommand(0xC)
#define	LcdDisplayOff()	LcdSendCommand(0x8)
#define	LcdCursorOn()  	LcdSendCommand(0xF)	// 0xE bez migania
#define	LcdCursorOff() 	LcdSendCommand(0xC)
#define	LcdHome()  		LcdSendCommand(0x2); lcdv=0; lcdh=0
#include "include/znaki.c";
uchar lcdv=0,lcdh=0;
void LcdDemo();
char buforU[64];


//**********************************************************************//
//						Bity konfiguracyjne		 						//
//**********************************************************************//
/*
__fuse_t __fuse __attribute__((section (".fuse"))) =
#if defined(__AVR_ATmega128__)
{
	.extended	= 0xFE,
	.high		= 0x99,
	.low		= 0x3F,
};
#else
	#error "NIEZNANY TYP PROCESORA w ustawieniu bitow konfiguracyjnych"
#endif
*/

/*
__attribute__((section (".lock"))) const unsigned char __lock =
0xFC;
*/



//**********************************************************************//
//						Program glowny			 						//
//**********************************************************************//
int main()
{
word podzial;
word s, d, newLen=0;
byte prevIMPdata=0;


	nop();

	InitTimer0();
	InitTimer1();
	InitTimer2();

	InitUart0();
	InitUart1();

	InitInt0();
	InitInt1();

	//--- init WDG ---
	//WDTO_15MS
	//WDTO_30MS
	//WDTO_60MS
	//WDTO_120MS
	//WDTO_250MS
	//WDTO_500MS
	//WDTO_1S
	//WDTO_2S
	wdt_enable( WDTO_500MS );									// Blokuje IRQ !!!


	IMPdata = eeprom_read_byte( &eeIMPdata ) & IMPdataMASK;		// Odczyt eeprom
	if ( (IMPdata & IMPdataMASK) == IMPdataMASK ) IMPdata = (IMPdataMASK >> 1) + 1;	// Jesli w eeprom bzdury to ustawiamy polowe
	ddrLedRun();


	sei();


	SendDmx( 24 );		// Init nadawania


	LcdInit();			// Inicjalizacja wywietlacza LCD	
	LcdDemo();
	LcdClr();


	//-----------------------------------------------------------------------------------
	//								Petla glowna
	//-----------------------------------------------------------------------------------
	while( 1 )
		{
		wdt_reset();


		if ( (!TimerLcd) || (prevIMPdata != IMPdata) )
			{
			TimerLcd = 30;		// Co 300ms odswierzamy LCD

			prevIMPdata = IMPdata;
			podzial = IMPdata << 4;

			LcdHome();
			sprintf(buforU,"1: %03d", LenDmx0 ); LcdPrint(buforU);
			if ( DmxStatus0 ){ LcdPrintChar('*'); } else { LcdPrintChar('-'); }
			sprintf(buforU,"  2: %03d", LenDmx1 ); LcdPrint(buforU);
			if ( DmxStatus1 ){ LcdPrintChar('*'); } else { LcdPrintChar('-'); }

			LcdSetCursorPosition(0,1);
			sprintf(buforU,"P: %03d   N: %03d", podzial, newLen ); LcdPrint(buforU);
			if ( DmxStatus0 || DmxStatus1 ){ LcdPrintChar('*'); } else { LcdPrintChar('-'); }
			}



		if ( !RdImpSw )
			{
			eeprom_write_byte ( &eeIMPdata, IMPdata );
			}



		//--- Wysanie ramki DMX ---//
		if ( TxEmpty )		// Jeli poprzednia ramka wyslana
			{
			d = 1;																		// Popiujemy od najtu 1 bo 0 zawsze rwny 0
			newLen = podzial + LenDmx1; if ( newLen > LENBUFDMX ) newLen = LENBUFDMX-1;	// Wyliczmy now dugo
			
			for (s=1; s<podzial+1; s++)
				{
				TxBuf0[ d++ ] = RxBuf0[ s ];			
				}		
			for (s=1; s<LENBUFDMX; s++)
				{
				TxBuf0[ d++ ] = RxBuf1[ s ];
				if ( d >= LENBUFDMX ) break;	// Kontrola dugoci	
				}		
			if ( (DmxStatus0 != DMX_OFFLINE) || (DmxStatus1 != DMX_OFFLINE))
				{
				SendDmx( newLen+1 );				// Nadajemy tylko gdy jest transmisja na ktrym porcie
				}
			else
				{
				newLen = 0;
				}
			}
		}
}



//**********************************************************************//



//-------------------------------------------------------------------------
//					Init timer 0
//-------------------------------------------------------------------------
void InitTimer0()
{
	TCCR0 = 7;							// podzielnik 1024
	TIMSK |= (1<<TOIE0);				// Zezwolenie na IRQ od przepelnienia timera
}


//----------------------------------------------------------------------//
//					Obsuga IRQ od timera 0 - czasy MAB
//----------------------------------------------------------------------//
INTERRUPT( TIMER0_OVF_vect )			// Mozliwe przerwanie wielopoziomowe (pierwsza instrukcja SEI)
{
byte dzielLedRun=2;


	TCNT0 = 256 - 157;					// Przerwania co okoo 10ms


	if ( TimerDmx0 ) TimerDmx0--;
	if ( TimerDmx1 ) TimerDmx1--;
	if ( TimerLcd )  TimerLcd--;

	if ( TimerDmx0 == 1) { DmxStatus0 = DMX_OFFLINE; LenDmx0 = 0; }
	if ( TimerDmx1 == 1) { DmxStatus1 = DMX_OFFLINE; LenDmx1 = 0; }

	if ( (--dzielLedRun)==0 )
		{
		dzielLedRun = 50;
		EorLedRun();
		}
}


//-------------------------------------------------------------------------
//					Init timer 1
//-------------------------------------------------------------------------
void InitTimer1()
{
	TCCR1B = ( CNT1_PRESCALER_64 );		// Preskaler na 256
										// F = 16000000/64 = 250kHz
										// t = 4us
	TCNT1 = 0xFFFF - 2;
//	TIMSK1 |= (1<<TOIE1);				// Zezwolenie na IRQ od przepelnienia timera
}



//----------------------------------------------------------------------//
//					Obsuga IRQ od timera 1 - PWM dla triaka
//----------------------------------------------------------------------//
//SIGNAL( TIMER1_OVF_vect )				// NIE MOZLIWE przerwanie wielopoziomowe (brak instrukcji SEI)
INTERRUPT( TIMER1_OVF_vect )			// MOZLIWE przerwanie wielopoziomowe (brak instrukcji SEI)
{


}


//----------------------------------------------------------------------//
//					Obsuga IRQ od porownania comparatora A				//
//----------------------------------------------------------------------//
INTERRUPT( TIMER1_COMPA_vect )			// MOZLIWE przerwanie wielopoziomowe (brak instrukcji SEI)
{

}


//----------------------------------------------------------------------//
//					Obsuga IRQ od porownania comparatora B				//
//----------------------------------------------------------------------//
INTERRUPT( TIMER1_COMPB_vect )			// MOZLIWE przerwanie wielopoziomowe (brak instrukcji SEI)
{

}


//-------------------------------------------------------------------------
//					Init timer 2
//-------------------------------------------------------------------------
void InitTimer2()
{
//	TCCR2B = CNT0_PRESCALER_8;				// Preskaler na 8 (liczymy us) 
}


//----------------------------------------------------------------------//
//					Obsuga IRQ od timera 2
//----------------------------------------------------------------------//
INTERRUPT( TIMER2_OVF_vect )			// Mozliwe przerwanie wielopoziomowe (pierwsza instrukcja SEI)
{
//	TCNT2_HH += 0x100;					// Zwiekszamy o 256
}


//--------------------------------------------------------------------------
//					Inicjalizacja INT 0
//--------------------------------------------------------------------------
void InitInt0()
{
	EIMSK  |= (1<<INT0);				// INT0   - Zezwolenie na IRQ od wejscia INT0
//	EICRA  |= (1<<ISC00);				// INT0   - Kazde zbocze na INT0 wywouje IRQ
	EICRA  |= (2<<ISC00);				// INT0   - Zbocze narastajace na INT0 wywouje IRQ

	PORTD |= (1<<PIND0) | (1<<PIND1);	// Wejcia A i B z podciganiem
	ddrImpSw();
}


//----------------------------------------------------------------------//
//					Obsuga IRQ od wejcia INT 0						//
//----------------------------------------------------------------------//
SIGNAL( INT0_vect )						// NIE MOZLIWE przerwanie wielopoziomowe (brak instrukcji SEI)
//INTERRUPT( INT0_vect )					// Mozliwe przerwanie wielopoziomowe (pierwsza instrukcja SEI)
{
byte data;


//	EIMSK  &= ~(1<<INT0);				// INT0   - Zablokuj IRQ od wejscia INT0


	data = IMPdata;
	if ( RdImpB )
		{
		data++;
		}
	else
		{
		data--;
		}
	data &= IMPdataMASK;				// ograniczenie zakresu
	IMPdata = data;

//	EIMSK  |= (1<<INT0);				// INT0   - Zezwolenie na IRQ od wejscia INT0
}



//--------------------------------------------------------------------------
//					Inicjalizacja INT 1
//--------------------------------------------------------------------------
void InitInt1()
{
	EIMSK  |= (1<<INT1);				// INT1   - Zezwolenie na IRQ od wejscia INT1
	EICRA  |= (1<<ISC10);				// INT1   - Kazde zbocze na INT1 wywouje IRQ
//	EICRA  |= (2<<ISC10);				// INT1   - Zbocze narastajace na INT1 wywouje IRQ

	PORTD |= (1<<PIND0) | (1<<PIND1);	// Wejcia A i B z podciganiem
	ddrImpSw();
}


//----------------------------------------------------------------------//
//					Obsuga IRQ od wejcia INT 1						//
//----------------------------------------------------------------------//
//SIGNAL( INT1_vect )					// NIE MOZLIWE przerwanie wielopoziomowe (brak instrukcji SEI)
INTERRUPT( INT1_vect )					// Mozliwe przerwanie wielopoziomowe (pierwsza instrukcja SEI)
{

}


//------------------------------------------------------------------------------
//					Inicjalizacja USART-a
//------------------------------------------------------------------------------
void InitUart0()
{
#if F_CPU == 16000000
	UBRR0H = 0;
	UBRR0L = 3;			// Dla 16MHz
	UCSR0A = 0;
#elif F_CPU == 8000000
	UBRR0H = 0;			// Dla 8MHz
	UBRR0L = 1;			// Tablica 19-11 str 196
	UCSR0A = 0;
//	UBRR0L = 3;			// Tablica 19-11 str 196
//	UCSR0A = (1<<U2X0);
#else
 #error "Nieznane FCLK"
#endif
	UCSR0B = (1<<RXEN0) | (1<<TXEN0) | (1<<RXCIE0) | (1<<TXCIE0);	
	UCSR0C = (1<<USBS0) | (3<<UCSZ00);								// Set frame format: 8data, 2stop bit
}


//----------------------------------------------------------------------//
//					Obsluga IRQ od odbiornika USART-a
//------------------------------------------------------------------------------
//#define USART_RX_vect     _VECTOR(18)  /* USART Rx Complete */
//#define USART_UDRE_vect   _VECTOR(19)  /* USART, Data Register Empty */
//
//INTERRUPT( USART_RX_vect )		// Mozliwe przerwanie wielopoziomowe
SIGNAL( USART0_RX_vect )			// Nie mozliwe przerwanie wielopoziomowe
{
byte UsartStatus, UsartDana;
word static CntDanych, curLenDmx, prevLenDmx;


	UsartStatus = UCSR0A;
	UsartDana = UDR0;
	UCSR0A = 0;


	if ( (UsartStatus & (1<<FE0)) )			// Jesli wykryto blad ramki to skonczyl sie sygnal BREAK
		{				
		TimerDmx0 = OVERTIME_DMX;
		DmxStatus0 = DMX_BREAK;				// Ustaw status
		prevLenDmx = curLenDmx;				// Zapamietaj poprzedni dugo
		curLenDmx = CntDanych;  			// Zapamitaj aktualn
		CntDanych = 0;						// Zeruj licznik danych
		if ( prevLenDmx==curLenDmx ) LenDmx0 = curLenDmx-1;	// Zapamitaj dugo danych gdy dwa wyniki takie same
		}
	else if(DmxStatus0 == DMX_BREAK)		// Jesli byl BREAK a pojawila sie nowa dana:
		{							
		if ( CntDanych < LENBUFDMX ) RxBuf0[ CntDanych++ ] = UsartDana;	// nastepny kanal
		}
}


//----------------------------------------------------------------------//
void SendDmx( word len )
{
	LenTxRs = len;
	if ( LenTxRs > LENBUFDMX ) LenTxRs = LENBUFDMX;
	TxEmpty = FALSE;

	// Program gwny generuje BREAK i MAB po czym wyle dane (wpis do UDR0)
	DdrTx();							// Port wyjsciem
	UCSR0B &= ~(1<<TXEN0);				// wycz TX UARTA
	ClrTx(); _delay_us(200);			// wygeneruj BREAK
	SetTx(); _delay_us(88);				// wygeneruj MAB
	UCSR0B |= (1<<TXEN0);				// wcz TX UARTA
	UDR0 = TxBuf0[ PtrTxRs=0 ];			// Wpisz do nadajnika pierwszy znak (start transmisji)
}


//----------------------------------------------------------------------//
//				Przerwanie nadawcze od uarta
//----------------------------------------------------------------------//
#define USART_UDRE_vect   _VECTOR(19)  /* USART, Data Register Empty */
#define USART_TX_vect     _VECTOR(20)  /* USART Tx Complete */
//----------------------------------------------------------------------//
SIGNAL(USART0_TX_vect)		// Musi byc ISR lub SIGNAL a nie INTERUPT
{
	PtrTxRs++;							// Wskanik na nastpny znak
	if ( PtrTxRs < LenTxRs )			// Jeli s jeszcze znaki do wysania
		{
		UDR0 = TxBuf0[ PtrTxRs ];		// Wpisz do nadajnika
		}
	else
		{
		TxEmpty = TRUE;					// Wszystkie znaki wysane (ostatnie IRQ)
		}
}


//------------------------------------------------------------------------------
//					Inicjalizacja USART-a
//------------------------------------------------------------------------------
void InitUart1()
{
#if F_CPU == 16000000
	UBRR1H = 0;
	UBRR1L = 3;			// Dla 16MHz
	UCSR1A = 0;
#elif F_CPU == 8000000
	UBRR1H = 0;			// Dla 8MHz
	UBRR1L = 1;			// Tablica 19-11 str 196
	UCSR1A = 0;
//	UBRR1L = 3;			// Tablica 19-11 str 196
//	UCSR1A = (1<<U2X0);
#else
 #error "Nieznane FCLK"
#endif
	UCSR1B = (1<<RXEN1) | (1<<RXCIE1);	
	UCSR1C = (1<<USBS1) | (3<<UCSZ10);								// Set frame format: 8data, 2stop bit
}


//----------------------------------------------------------------------//
//					Obsluga IRQ od odbiornika USART-a
//------------------------------------------------------------------------------
//#define USART_RX_vect     _VECTOR(18)  /* USART Rx Complete */
//#define USART_UDRE_vect   _VECTOR(19)  /* USART, Data Register Empty */
//
//INTERRUPT( USART_RX_vect )		// Mozliwe przerwanie wielopoziomowe
SIGNAL( USART1_RX_vect )			// Nie mozliwe przerwanie wielopoziomowe
{
byte UsartStatus, UsartDana;
word static CntDanych, curLenDmx, prevLenDmx;


	UsartStatus = UCSR1A;
	UsartDana = UDR1;
	UCSR1A = 0;


	if ( (UsartStatus & (1<<FE1)) )			// Jesli wykryto blad ramki to skonczyl sie sygnal BREAK
		{				
		TimerDmx1 = OVERTIME_DMX;
		DmxStatus1 = DMX_BREAK;				// Ustaw status
		prevLenDmx = curLenDmx;				// Zapamietaj poprzedni dugo
		curLenDmx = CntDanych;  			// Zapamitaj aktualn
		CntDanych = 0;						// Zeruj licznik danych
		if ( prevLenDmx==curLenDmx ) LenDmx1 = curLenDmx-1;	// Zapamitaj dugo danych gdy dwa wyniki takie same
		}
	else if(DmxStatus1 == DMX_BREAK)		// Jesli byl BREAK a pojawila sie nowa dana:
		{							
		if ( CntDanych < LENBUFDMX ) RxBuf1[ CntDanych++ ] = UsartDana;	// nastepny kanal
		}
}



/******************************************************************/
//			Init LCD
//-----------------------------------------------------------------
void LcdInit()
{
byte x;

 	LcdRSddr;								// Porty wyjciami
	LcdEddr;
	LcdEclr;								// E=0
	LcdDataOut();
	LcdRSclr;								// RS=0
  	_delay_ms(50);


	LcdSendNible(0x03); 					// Init magistrali 8-bit
  	_delay_ms(10);
	LcdSendNible(0x03); 					// Init magistrali 8-bit
 	_delay_ms(1);
	LcdSendNible(0x03); 					// Init magistrali 8-bit

	#ifdef LCD8BIT
	 LcdSendCommand(0x33); 					// Init magistrali 8-bit
  	 LcdSendCommand(0x38); 					// FunctionSet 	%0011_1000	(0  0  1 DL  N  F  -  -) DL=1 8bit, N=1 2lines, F=1 5*10dots
	#else
	 LcdSendNible(0x02); 					// Init magistrali 4-bit
	 LcdSendCommand(0x28); 					// FunctionSet 	%0010_1000	(0  0  1 DL  N  F  -  -) DL=0 4bit, N=1 2lines, F=1 5*10dots
	#endif

	LcdSendCommand(0x0C);					// DisplayOnOff	%0000_1100	(0  0  0  0  1  D  C  B) D-on/off, C-cursor on/of, B-blinking character
	LcdSendCommand(0x01);  					// DisplayClr	%0000_0001	(0  0  0  0  0  0  0  1)
	LcdSendCommand(0x06);					// EntryModeSet	%0000_0110	(0  0  0  0  0  1 ID  S) ID=1 increment, S=1

	LcdDispayOn();

	//--- wysanie wzorow polskich znakw ---
	LcdSendCommand(0x40);					// Ustawienie na pocztek generatora znakw
	for	(x=0; x<64; x++)					// Liczba bajtw generatora
		{
		LcdSendData( pgm_read_byte( &znaki_pl[x]) );
		}

	LcdHome();
}




//-----------------------------------------------------------------
//			Ustawienie linii danych jako wyjcia
//-----------------------------------------------------------------
void LcdDataOut()
{
	#ifdef LCD8BIT
	 LcdD0ddr; LcdD1ddr; LcdD2ddr; LcdD3ddr;
	#endif
	LcdD4ddr; LcdD5ddr; LcdD6ddr; LcdD7ddr;
}



//-----------------------------------------------------------------
void LcdClr()
{
	 LcdSendCommand(0x1);
	 lcdv=0; lcdh=0;
}



//-----------------------------------------------------------------
void LcdSendCommand(unsigned char data)
{
	LcdDataOut();
  	LcdRSclr;								// RS=0;
	#ifdef LCD8BIT
	 LcdSendByte( data );
	#else
	 LcdSendNible( data >> 4 );  			// Starsze 4 bity
 	 LcdSendNible( data ); 		 			// Modsze 4 bity
	#endif
	//--- Oczekiwanie na zakoczenie operacji ---
	if ( (data & 2) == 2 ) { _delay_ms(2); }		// LcdHome 1,5ms
	else if ( (data & 2) == 1 ) { _delay_ms(2); }	// Clear Display ?,?ms
	_delay_us(40);									// Pozostae rozkazy 37us
}



//-----------------------------------------------------------------
#ifndef LCD8BIT
void LcdSendNible(unsigned char data)
{
//#define	DELAYLCD	180					// 180us juz jest ok na tamie 15cm
//#define	DELAYLCD	250					// 250us jest gdy na D0..D3 jest klawiatura
#define	DELAYLCD	500						// 500us dla Pulpitu AudioMux


//	LcdD0clr; LcdD1clr; LcdD2clr; LcdD3clr;	// Nieuywane linie do masy
	if ((data & 1) != 0) {LcdD4set;} else LcdD4clr;
	if ((data & 2) != 0) {LcdD5set;} else LcdD5clr;
	if ((data & 4) != 0) {LcdD6set;} else LcdD6clr;
	if ((data & 8) != 0) {LcdD7set;} else LcdD7clr;
 	_delay_us(DELAYLCD);
	LcdEset;								// E=1
	_delay_us(DELAYLCD);
	LcdEclr;								// E=0
	#ifndef LCDIRQ
	_delay_us(DELAYLCD);
	#endif
}
#endif


//-----------------------------------------------------------------
#ifdef LCD8BIT
void LcdSendByte(unsigned char data)
{
	if ((data & 0x01) != 0) {LcdD0set;} else LcdD0clr;
	if ((data & 0x02) != 0) {LcdD1set;} else LcdD1clr;
	if ((data & 0x04) != 0) {LcdD2set;} else LcdD2clr;
	if ((data & 0x08) != 0) {LcdD3set;} else LcdD3clr;
	if ((data & 0x10) != 0) {LcdD4set;} else LcdD4clr;
	if ((data & 0x20) != 0) {LcdD5set;} else LcdD5clr;
	if ((data & 0x40) != 0) {LcdD6set;} else LcdD6clr;
	if ((data & 0x80) != 0) {LcdD7set;} else LcdD7clr;
 	_delay_us(DELAYLCD);
	LcdEset;								// E=1
	_delay_us(DELAYLCD);
	LcdEclr;								// E=0
	#ifndef LCDIRQ
	_delay_us(DELAYLCD);
	#endif
}
#endif



//-----------------------------------------------------------------
void LcdSendData(unsigned char data)
{
	LcdDataOut();
	LcdRSset;								// RS=1
	#ifdef LCD8BIT
	 LcdSendByte( data );
	#else
	 LcdSendNible( data >> 4 );  			// Starsze 4 bity
	 LcdSendNible( data ); 		 			// Modsze 4 bity
	#endif
}



//-----------------------------------------------------------------
void LcdNextLine()
{
	lcdh = 0;
	if ( (++lcdv) >= LCDLINE) lcdv=0;
	LcdSetCursorPosition(lcdh,lcdv);
}



//-----------------------------------------------------------------
void LcdPrintChar(char character)
{
	LcdSendData(character);


	if ( (++lcdh) >= LCDROW)			// Po zapisaniu znaku
		{								// Jeli przektroczono dugo wiersza to:
		if ( (++lcdv) >= LCDLINE)		// Nastpny wiersz, jeli ostatni to:
			{
			LcdHome();					// Wracamy na poczatek
			}
		switch(lcdv)
			{
			case(0): LcdSetCursorPosition(0,0); break;
			case(1): LcdSetCursorPosition(0,1); break;
			case(2): LcdSetCursorPosition(0,2); break;
			case(3): LcdSetCursorPosition(0,3); break;
			}
		}
}



//-----------------------------------------------------------------
void LcdSetCursorPosition(unsigned char row,unsigned char line)
{
	lcdh = row;
	lcdv = line;
	#if LCDLINE == 2
  	if(line==1) row += 0x40;		// Pawdziwe dla wyswietlaczy 2 * x
	#endif
	#if LCDLINE == 4
  	if(line==1) row += 0x40;		// Pawdziwe dla wyswietlaczy 4 * x
  	if(line==2) row += LCDROW;		// Pawdziwe dla wyswietlaczy 4 * x
  	if(line==3) row += 0x40+LCDROW;	// Pawdziwe dla wyswietlaczy 4 * x
	#endif
  	row |= 0x80;					// Kod rozkazu ($80) OR pozycja w RAM LCD
  	LcdSendCommand(row);
}



//-----------------------------------------------------------------
void LcdPrint(char *text)
{
char znak;

	while (*text)					// Wyswietl tekst z RAMu
  	 	{
		znak = (*text);
		znak = LcdWin2Lcd(znak);
		LcdPrintChar(znak);
   		text++;
		}
}



//-----------------------------------------------------------------
void LcdPrint_P(char *text)
{
char znak,x;

	for (x=0; x<80; x++)			// Wyswietl tekst z FLASH-a
  	 	{
		znak = pgm_read_byte(text);
		if ( znak == 0 ) break;
		znak = LcdWin2Lcd(znak);
		LcdPrintChar(znak);
   		text++;
		}
}



//-----------------------------------------------------------------
char LcdWin2Lcd(char znak)
{
	switch(znak)
		{
		case(''): return(0);
		case(''): return(1);
		case(''): return(2);
		case(''): return(3);
		case(''): return(4);
		case(''): return(5);
		case(''): return(6);
		case(''): return(7);
		case(''): return(7);
		case(''): return(0);
		case(''): return(1);
		case(''): return(2);
		case(''): return(3);
		case(''): return(4);
		case(''): return(5);
		case(''): return(6);
		case(''): return(7);
		case(''): return(7);
		}
	return(znak);
}



//-----------------------------------------------------------------
void LcdPutCGRAM(byte NrZnaku)
{
byte x;


	LcdDataOut();
	//--- wysanie wzoru znaku ---

	LcdSendCommand(0x40 + (NrZnaku<<3) );	// Ustawienie generatora znakw
	for	(x=0; x<8; x++)						// Liczba bajtw znaku
		{
		LcdSendData( pgm_read_byte( &znaki_pl[x]) );
		}
}


//-----------------------------------------------------------------
void LcdDemo()
{
byte x;

	LcdClr();
	LcdPrint_P(PSTR("DMX-Mereger V1.0")); 

//	LcdSetCursorPosition(0,1);
//	LcdPrint_P(PSTR(VER));

	LcdSetCursorPosition(0,1);
	LcdPrint_P(PSTR("(C) 2014 AVT"));

	for (x=0; x<6; x++){ wdt_reset(); _delay_ms(250); }
}


//**********************************************************************//

